Index: frontends/php/include/regexp.inc.php
===================================================================
--- frontends/php/include/regexp.inc.php	(revision 38884)
+++ frontends/php/include/regexp.inc.php	(working copy)
@@ -23,7 +23,7 @@
 	$sql = 'SELECT re.* '.
 					' FROM regexps re '.
 					' WHERE '.DBin_node('re.regexpid').
-						' AND regexpid='.$regexpid;
+						' AND regexpid='.zbx_dbstr($regexpid);
 
 	$db_regexp = DBfetch(DBselect($sql));
 return $db_regexp;
@@ -80,7 +80,7 @@
 	$sql = 'UPDATE regexps SET '.
 				' name='.zbx_dbstr($regexp['name']).','.
 				' test_string='.zbx_dbstr($regexp['test_string']).
-			' WHERE regexpid='.$regexpid;
+			' WHERE regexpid='.zbx_dbstr($regexpid);
 	$result = DBexecute($sql);
 return $result;
 }
@@ -117,8 +117,8 @@
 				' VALUES ('.$expressionid.','.
 						$regexpid.','.
 						zbx_dbstr($expression['expression']).','.
-						$expression['expression_type'].','.
-						$expression['case_sensitive'].','.
+						zbx_dbstr($expression['expression_type']).','.
+						zbx_dbstr($expression['case_sensitive']).','.
 						zbx_dbstr($expression['exp_delimiter']).')');
 
 return $result?$expressionid:false;
Index: frontends/php/include/actions.inc.php
===================================================================
--- frontends/php/include/actions.inc.php	(revision 38884)
+++ frontends/php/include/actions.inc.php	(working copy)
@@ -95,7 +95,7 @@
 }
 
 function get_action_by_actionid($actionid){
-	$sql='select * from actions where actionid='.$actionid;
+	$sql='select * from actions where actionid='.zbx_dbstr($actionid);
 	$result=DBselect($sql);
 
 	if($row=DBfetch($result)){
@@ -220,7 +220,7 @@
 			break;
 		case CONDITION_TYPE_DCHECK:
 			$row = DBfetch(DBselect('SELECT DISTINCT r.name,c.dcheckid,c.type,c.key_,c.snmp_community,c.ports'.
-					' FROM drules r,dchecks c WHERE r.druleid=c.druleid AND c.dcheckid='.$value));
+					' FROM drules r,dchecks c WHERE r.druleid=c.druleid AND c.dcheckid='.zbx_dbstr($value)));
 			$str_val = $row['name'].':'.discovery_check2str($row['type'],
 					$row['snmp_community'], $row['key_'], $row['ports']);
 			break;
@@ -342,7 +342,7 @@
 							$sql = 'SELECT a.def_shortdata,a.def_longdata '.
 									' FROM actions a, operations o '.
 									' WHERE a.actionid=o.actionid '.
-										' AND o.operationid='.$data['operationid'];
+										' AND o.operationid='.zbx_dbstr($data['operationid']);
 							if($rows = DBfetch(DBselect($sql,1))){
 								$temp = bold(S_SUBJECT.': ');
 								$result = $temp->ToString()."\n".$rows['def_shortdata']."\n";
@@ -583,7 +583,7 @@
 
 function	update_action_status($actionid, $status)
 {
-	return DBexecute("update actions set status=$status where actionid=$actionid");
+	return DBexecute('update actions set status='.zbx_dbstr($status).' where actionid='.zbx_dbstr($actionid));
 }
 
 function validate_condition($conditiontype, $value){
@@ -1037,7 +1037,7 @@
 	$hostids = array();
 	$sql = 'SELECT DISTINCT i.hostid '.
 			' FROM events e, functions f, items i '.
-			' WHERE e.eventid='.$eventid.
+			' WHERE e.eventid='.zbx_dbstr($eventid).
 				' AND e.object='.EVENT_SOURCE_TRIGGERS.
 				' AND f.triggerid=e.objectid '.
 				' AND i.itemid=f.itemid';
@@ -1071,8 +1071,8 @@
 			' FROM events e,alerts a '.
 				' LEFT JOIN users u ON u.userid=a.userid '.
 				' LEFT JOIN media_type mt ON mt.mediatypeid=a.mediatypeid'.
-			' WHERE a.eventid='.$eventid.
-				(is_null($status)?'':' AND a.status='.$status).
+			' WHERE a.eventid='.zbx_dbstr($eventid).
+				(is_null($status)?'':' AND a.status='.zbx_dbstr($status)).
 				' AND e.eventid = a.eventid'.
 				' AND a.alerttype IN ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 				' AND '.DBcondition('e.objectid',$available_triggers).
@@ -1127,7 +1127,7 @@
 
 	$sql='SELECT COUNT(a.alertid) as cnt_all'.
 			' FROM alerts a '.
-			' WHERE a.eventid='.$eventid.
+			' WHERE a.eventid='.zbx_dbstr($eventid).
 				' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')';
 
 	$alerts=DBfetch(DBselect($sql));
@@ -1137,7 +1137,7 @@
 // Sent
 		$sql='SELECT COUNT(a.alertid) as sent '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_SENT;
 
@@ -1147,7 +1147,7 @@
 // In progress
 		$sql='SELECT COUNT(a.alertid) as inprogress '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_NOT_SENT;
 
@@ -1156,7 +1156,7 @@
 // Failed
 		$sql='SELECT COUNT(a.alertid) as failed '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_FAILED;
 
@@ -1194,7 +1194,7 @@
 
 	$sql='SELECT COUNT(a.alertid) as cnt '.
 			' FROM alerts a '.
-			' WHERE a.eventid='.$eventid.
+			' WHERE a.eventid='.zbx_dbstr($eventid).
 				' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')';
 
 
@@ -1203,7 +1203,7 @@
 	if(isset($alerts['cnt']) && ($alerts['cnt'] > 0)){
 		$sql='SELECT COUNT(a.alertid) as sent '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_SENT;
 
@@ -1219,7 +1219,7 @@
 
 		$sql='SELECT COUNT(a.alertid) as inprogress '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_NOT_SENT;
 
@@ -1235,7 +1235,7 @@
 
 		$sql='SELECT COUNT(a.alertid) as failed '.
 				' FROM alerts a '.
-				' WHERE a.eventid='.$eventid.
+				' WHERE a.eventid='.zbx_dbstr($eventid).
 					' AND a.alerttype in ('.ALERT_TYPE_MESSAGE.','.ALERT_TYPE_COMMAND.')'.
 					' AND a.status='.ALERT_STATUS_FAILED;
 
Index: frontends/php/include/screens.inc.php
===================================================================
--- frontends/php/include/screens.inc.php	(revision 38884)
+++ frontends/php/include/screens.inc.php	(working copy)
@@ -26,7 +26,7 @@
 <?php
 
 	function get_screen_by_screenid($screenid){
-		$result = DBselect("select * from screens where screenid=$screenid");
+		$result = DBselect('select * from screens where screenid='.zbx_dbstr($screenid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -38,8 +38,7 @@
 	function check_screen_recursion($mother_screenid, $child_screenid){
 		if((bccomp($mother_screenid , $child_screenid)==0))	return TRUE;
 
-		$db_scr_items = DBselect("select resourceid from screens_items where".
-			" screenid=$child_screenid and resourcetype=".SCREEN_RESOURCE_SCREEN);
+		$db_scr_items = DBselect('select resourceid from screens_items where screenid='.zbx_dbstr($child_screenid).' and resourcetype='.SCREEN_RESOURCE_SCREEN);
 		while($scr_item = DBfetch($db_scr_items)){
 			if(check_screen_recursion($mother_screenid,$scr_item["resourceid"]))
 				return TRUE;
@@ -50,7 +49,7 @@
 	function get_slideshow($slideshowid, $step, $effectiveperiod=NULL){
 		$sql = 'SELECT min(step) as min_step, max(step) as max_step '.
 				' FROM slides '.
-				' WHERE slideshowid='.$slideshowid;
+				' WHERE slideshowid='.zbx_dbstr($slideshowid);
 		$slide_data = DBfetch(DBselect($sql));
 		if(!$slide_data || is_null($slide_data['min_step'])){
 			return false;
@@ -66,9 +65,9 @@
 
 		$sql = 'SELECT sl.* '.
 				' FROM slides sl, slideshows ss '.
-				' WHERE ss.slideshowid='.$slideshowid.
+				' WHERE ss.slideshowid='.zbx_dbstr($slideshowid).
 					' and sl.slideshowid=ss.slideshowid '.
-					' and sl.step='.$curr_step;
+					' and sl.step='.zbx_dbstr($curr_step);
 		$slide_data = DBfetch(DBselect($sql));
 
 	return $slide_data;
@@ -80,7 +79,7 @@
 
 		$sql = 'SELECT slideshowid '.
 				' FROM slideshows '.
-				' WHERE slideshowid='.$slideshowid.
+				' WHERE slideshowid='.zbx_dbstr($slideshowid).
 					' AND '.DBin_node('slideshowid', get_current_nodeid(null,$perm));
 		if(DBselect($sql)){
 			$result = true;
@@ -88,7 +87,7 @@
 			$screenids = array();
 			$sql = 'SELECT DISTINCT screenid '.
 					' FROM slides '.
-					' WHERE slideshowid='.$slideshowid;
+					' WHERE slideshowid='.zbx_dbstr($slideshowid);
 			$db_screens = DBselect($sql);
 			while($slide_data = DBfetch($db_screens)){
 				$screenids[$slide_data['screenid']] = $slide_data['screenid'];
@@ -111,7 +110,7 @@
 	}
 
 	function get_slideshow_by_slideshowid($slideshowid){
-		return DBfetch(DBselect('select * from slideshows where slideshowid='.$slideshowid));
+		return DBfetch(DBselect('select * from slideshows where slideshowid='.zbx_dbstr($slideshowid)));
 	}
 
 	function add_slideshow($name, $delay, $slides){
@@ -144,7 +143,7 @@
 
 // TODO: resulve conflict about regression of delay per slide
 			$result = DBexecute('INSERT INTO slides (slideid,slideshowid,screenid,step,delay) '.
-								' VALUES ('.$slideid.','.$slideshowid.','.$slide['screenid'].','.($i++).','.$slide['delay'].')');
+								' VALUES ('.$slideid.','.zbx_dbstr($slideshowid).','.zbx_dbstr($slide['screenid']).','.($i++).','.zbx_dbstr($slide['delay']).')');
 			if(!$result) return false;
 		}
 
@@ -171,17 +170,17 @@
 			if(!isset($slide['delay'])) $slide['delay'] = 0;
 		}
 
-		if(!$result = DBexecute('UPDATE slideshows SET name='.zbx_dbstr($name).',delay='.$delay.' WHERE slideshowid='.$slideshowid))
+		if(!$result = DBexecute('UPDATE slideshows SET name='.zbx_dbstr($name).',delay='.zbx_dbstr($delay).' WHERE slideshowid='.zbx_dbstr($slideshowid)))
 			return false;
 
-		DBexecute('DELETE FROM slides where slideshowid='.$slideshowid);
+		DBexecute('DELETE FROM slides where slideshowid='.zbx_dbstr($slideshowid));
 
 		$i = 0;
 		foreach($slides as $slide){
 			$slideid = get_dbid('slides','slideid');
 			if(!isset($slide['delay'])) $slide['delay'] = $delay;
 			$result = DBexecute('INSERT INTO slides (slideid,slideshowid,screenid,step,delay) '.
-				' VALUES ('.$slideid.','.$slideshowid.','.$slide['screenid'].','.($i++).','.$slide['delay'].')');
+				' VALUES ('.$slideid.','.zbx_dbstr($slideshowid).','.zbx_dbstr($slide['screenid']).','.($i++).','.zbx_dbstr($slide['delay']).')');
 			if(!$result){
 				return false;
 			}
@@ -192,9 +191,9 @@
 
 	function delete_slideshow($slideshowid){
 
-		$result = DBexecute('DELETE FROM slideshows where slideshowid='.$slideshowid);
-		$result &= DBexecute('DELETE FROM slides where slideshowid='.$slideshowid);
-		$result &= DBexecute("DELETE FROM profiles WHERE idx='web.favorite.screenids' AND source='slideshowid' AND value_id=$slideshowid");
+		$result = DBexecute('DELETE FROM slideshows where slideshowid='.zbx_dbstr($slideshowid));
+		$result &= DBexecute('DELETE FROM slides where slideshowid='.zbx_dbstr($slideshowid));
+		$result &= DBexecute('DELETE FROM profiles WHERE idx=\'web.favorite.screenids\' AND source=\'slideshowid\' AND value_id='.zbx_dbstr($slideshowid));
 
 		return $result;
 	}
@@ -282,13 +281,13 @@
 		if($config == 0){
 			$sql = 'SELECT screenitemid '.
 			' FROM screens_items '.
-			' WHERE screenid='.$elid.
+			' WHERE screenid='.zbx_dbstr($elid).
 				' AND dynamic='.SCREEN_DYNAMIC_ITEM;
 		}
 		else{
 			$sql = 'SELECT si.screenitemid '.
 			' FROM slides s, screens_items si '.
-			' WHERE s.slideshowid='.$elid.
+			' WHERE s.slideshowid='.zbx_dbstr($elid).
 				' AND si.screenid=s.screenid'.
 				' AND si.dynamic='.SCREEN_DYNAMIC_ITEM;
 		}
@@ -306,8 +305,8 @@
 		if(isset($_REQUEST['screenitemid'])){
 			$sql = 'SELECT * '.
 					' FROM screens_items'.
-					' WHERE screenid='.$_REQUEST['screenid'].
-						' AND screenitemid='.$_REQUEST['screenitemid'];
+					' WHERE screenid='.zbx_dbstr($_REQUEST['screenid']).
+						' AND screenitemid='.zbx_dbstr($_REQUEST['screenitemid']);
 			$iresult=DBSelect($sql);
 
 			$form->addVar('screenitemid',$_REQUEST['screenitemid']);
@@ -600,7 +599,7 @@
 				$result=DBselect('SELECT DISTINCT n.name as node_name,s.screenid,s.name '.
 							' FROM screens s '.
 								' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('s.screenid').
-							' WHERE s.screenid='.$resourceid);
+							' WHERE s.screenid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$r = CScreen::get(array(
@@ -635,7 +634,7 @@
 						' FROM hosts_groups hg, groups g '.
 							' LEFT JOIN nodes n ON n.nodeid='.DBid2nodeid('g.groupid').
 						' WHERE '.DBcondition('g.groupid',$available_groups).
-							' AND g.groupid='.$resourceid);
+							' AND g.groupid='.zbx_dbstr($resourceid));
 
 				while($row=DBfetch($result)){
 					$row['node_name'] = isset($row['node_name']) ? '('.$row['node_name'].') ' : '';
@@ -770,11 +769,11 @@
 		if(is_null($effectiveperiod))
 			$effectiveperiod = ZBX_MIN_PERIOD;
 
-		$result=DBselect('SELECT name,hsize,vsize FROM screens WHERE screenid='.$screenid);
+		$result=DBselect('SELECT name,hsize,vsize FROM screens WHERE screenid='.zbx_dbstr($screenid));
 		$row=DBfetch($result);
 		if(!$row) return new CTableInfo(S_NO_SCREENS_DEFINED);
 
-		$sql = 'SELECT * FROM screens_items WHERE screenid='.$screenid;
+		$sql = 'SELECT * FROM screens_items WHERE screenid='.zbx_dbstr($screenid);
 		$iresult = DBSelect($sql);
 
 		$skip_field = array();
Index: frontends/php/include/perm.inc.php
===================================================================
--- frontends/php/include/perm.inc.php	(revision 38884)
+++ frontends/php/include/perm.inc.php	(working copy)
@@ -24,7 +24,7 @@
 	$sessionid = md5(time().$password.$name.rand(0,10000000));
 	zbx_setcookie('zbx_sessionid',$sessionid);
 
-	DBexecute('INSERT INTO sessions (sessionid,userid,lastaccess,status) VALUES ('.zbx_dbstr($sessionid).','.$userid.','.time().','.ZBX_SESSION_ACTIVE.')');
+	DBexecute('INSERT INTO sessions (sessionid,userid,lastaccess,status) VALUES ('.zbx_dbstr($sessionid).','.zbx_dbstr($userid).','.time().','.ZBX_SESSION_ACTIVE.')');
 
 return $sessionid;
 }
@@ -84,7 +84,7 @@
 function  check_perm2system($userid){
 	$sql = 'SELECT g.usrgrpid '.
 		' FROM usrgrp g, users_groups ug '.
-		' WHERE ug.userid = '.$userid.
+		' WHERE ug.userid = '.zbx_dbstr($userid).
 			' AND g.usrgrpid = ug.usrgrpid '.
 			' AND g.users_status = '.GROUP_STATUS_DISABLED;
 	if($res = DBfetch(DBselect($sql,1))){
@@ -128,7 +128,7 @@
 
 	$sql = 'SELECT MAX(g.gui_access) as gui_access '.
 		' FROM usrgrp g, users_groups ug '.
-		' WHERE ug.userid='.$userid.
+		' WHERE ug.userid='.zbx_dbstr($userid).
 			' AND g.usrgrpid=ug.usrgrpid ';
 	$acc = DBfetch(DBselect($sql));
 
@@ -142,7 +142,7 @@
 function get_user_debug_mode($userid){
 	$sql = 'SELECT g.usrgrpid '.
 			' FROM usrgrp g, users_groups ug '.
-			' WHERE ug.userid = '.$userid.
+			' WHERE ug.userid = '.zbx_dbstr($userid).
 				' AND g.usrgrpid = ug.usrgrpid '.
 				' AND g.debug_mode = '.GROUP_DEBUG_MODE_ENABLED;
 	if($res = DBfetch(DBselect($sql,1))){
@@ -261,7 +261,7 @@
 			' LEFT JOIN hosts_groups hg ON hg.hostid=h.hostid '.
 			' LEFT JOIN groups g ON g.groupid=hg.groupid '.
 			' LEFT JOIN rights r ON r.id=g.groupid '.
-			' LEFT JOIN users_groups ug ON ug.usrgrpid=r.groupid and ug.userid='.$userid.
+			' LEFT JOIN users_groups ug ON ug.usrgrpid=r.groupid and ug.userid='.zbx_dbstr($userid).
 			' LEFT JOIN nodes n ON '.DBid2nodeid('h.hostid').'=n.nodeid '.
 		$where.
 		' GROUP BY h.hostid,n.nodeid,n.name,h.host,ug.userid '.
@@ -444,7 +444,7 @@
 	foreach($node_data as $nodeid => $node){
 		switch($perm_res){
 			case PERM_RES_DATA_ARRAY:
-				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.$nodeid.' ORDER BY name'));
+				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.zbx_dbstr($nodeid).' ORDER BY name'));
 
 				if(!ZBX_DISTRIBUTED){
 					if(!$node){
@@ -671,7 +671,7 @@
 	foreach($node_data as $nodeid => $node){
 		switch($perm_res){
 			case PERM_RES_DATA_ARRAY:
-				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.$nodeid));
+				$db_node = DBfetch(DBselect('SELECT * FROM nodes WHERE nodeid='.zbx_dbstr($nodeid)));
 
 				if(!ZBX_DISTRIBUTED){
 					if(!$node){
Index: frontends/php/include/blocks.inc.php
===================================================================
--- frontends/php/include/blocks.inc.php	(revision 38884)
+++ frontends/php/include/blocks.inc.php	(working copy)
@@ -982,7 +982,7 @@
 		$event_sql = 'SELECT e.eventid, e.value, e.clock, e.objectid as triggerid, e.acknowledged'.
 					' FROM events e'.
 					' WHERE e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.objectid='.$trigger['triggerid'].
+						' AND e.objectid='.zbx_dbstr($trigger['triggerid']).
 						' AND e.value='.TRIGGER_VALUE_TRUE.
 					' ORDER by e.object DESC, e.objectid DESC, e.eventid DESC';
 		$res_events = DBSelect($event_sql,1);
@@ -1073,7 +1073,7 @@
 
 		$sql = 'SELECT DISTINCT ht.name, ht.httptestid, ht.curstate, ht.lastfailedstep '.
 				' FROM httptest ht, applications a, hosts_groups hg, groups g '.
-				' WHERE g.groupid='.$group['groupid'].
+				' WHERE g.groupid='.zbx_dbstr($group['groupid']).
 					' AND '.DBcondition('hg.hostid',$available_hosts).
 					' AND hg.groupid=g.groupid '.
 					' AND a.hostid=hg.hostid '.
Index: frontends/php/include/export.inc.php
===================================================================
--- frontends/php/include/export.inc.php	(revision 38884)
+++ frontends/php/include/export.inc.php	(working copy)
@@ -756,7 +756,7 @@
 
 // Deleteing all selements (with links)
 					$db_selementids = array();
-					$res = DBselect('SELECT selementid FROM sysmaps_elements WHERE sysmapid='.$sysmap['sysmapid']);
+					$res = DBselect('SELECT selementid FROM sysmaps_elements WHERE sysmapid='.zbx_dbstr($sysmap['sysmapid']));
 					while($db_selement = DBfetch($res)){
 						$db_selementids[$db_selement['selementid']] = $db_selement['selementid'];
 					}
Index: frontends/php/include/items.inc.php
===================================================================
--- frontends/php/include/items.inc.php	(revision 38884)
+++ frontends/php/include/items.inc.php	(working copy)
@@ -192,7 +192,7 @@
 	function update_item_in_group($groupid,$itemid,$item){
 		$sql='SELECT i.itemid,i.hostid '.
 				' FROM hosts_groups hg,items i '.
-				' WHERE hg.groupid='.$groupid.
+				' WHERE hg.groupid='.zbx_dbstr($groupid).
 					' and i.key_='.zbx_dbstr($item['key_']).
 					' and hg.hostid=i.hostid';
 		$result=DBSelect($sql);
@@ -217,7 +217,7 @@
 		$del_items = array();
 		$sql='SELECT i.itemid '.
 			' FROM hosts_groups hg,items i'.
-			' WHERE hg.groupid='.$groupid.
+			' WHERE hg.groupid='.zbx_dbstr($groupid).
 				' AND i.key_='.zbx_dbstr($item["key_"]).
 				' AND hg.hostid=i.hostid';
 		$result=DBSelect($sql);
@@ -233,7 +233,7 @@
 	# Add Item definition to selected group
 
 	function add_item_to_group($groupid,$item){
-		$sql='SELECT hostid FROM hosts_groups WHERE groupid='.$groupid;
+		$sql='SELECT hostid FROM hosts_groups WHERE groupid='.zbx_dbstr($groupid);
 		$result=DBSelect($sql);
 		while($row=DBfetch($result)){
 			$item['hostid'] = $row['hostid'];
@@ -371,7 +371,7 @@
 
 		$sql = 'SELECT itemid, hostid, templateid '.
 				' FROM items '.
-				' WHERE hostid='.$item['hostid'].
+				' WHERE hostid='.zbx_dbstr($item['hostid']).
 					' AND key_='.zbx_dbstr($item['key_']);
 		$db_item = DBfetch(DBselect($sql));
 		if($db_item && (($item['templateid'] == 0) || (($db_item['templateid'] != 0) && ($item['templateid'] != 0) && ($item['templateid'] != $db_item['templateid'])))){
@@ -396,15 +396,15 @@
 					'delta,snmpv3_securityname,snmpv3_securitylevel,snmpv3_authpassphrase,'.
 					'snmpv3_privpassphrase,formula,trends,logtimefmt,valuemapid,'.
 					'delay_flex,params,ipmi_sensor,templateid,authtype,username,password,publickey,privatekey)'.
-			' VALUES ('.$itemid.','.zbx_dbstr($item['description']).','.zbx_dbstr($item['key_']).','.(!$item['hostid']? '0':$item['hostid']).','.
-						(!$item['delay']? '0':$item['delay']).','.(!$item['history']? '0':$item['history']).','.(!$item['status']? '0':$item['status']).','.(!$item['type']? '0':$item['type']).','.
-						zbx_dbstr($item['snmp_community']).','.zbx_dbstr($item['snmp_oid']).','.(!$item['value_type']? '0':$item['value_type']).','.(!$item['data_type']? '0':$item['data_type']).','.
-						zbx_dbstr($item['trapper_hosts']).','.$item['snmp_port'].','.zbx_dbstr($item['units']).','.(!$item['multiplier'] ? '0':$item['multiplier']).','.
+			' VALUES ('.$itemid.','.zbx_dbstr($item['description']).','.zbx_dbstr($item['key_']).','.(!$item['hostid']? '0':zbx_dbstr($item['hostid'])).','.
+						(!$item['delay']? '0':zbx_dbstr($item['delay'])).','.(!$item['history']? '0':zbx_dbstr($item['history'])).','.(!$item['status']? '0':zbx_dbstr($item['status'])).','.(!$item['type']? '0':zbx_dbstr($item['type'])).','.
+						zbx_dbstr($item['snmp_community']).','.zbx_dbstr($item['snmp_oid']).','.(!$item['value_type']? '0':zbx_dbstr($item['value_type'])).','.(!$item['data_type']? '0':zbx_dbstr($item['data_type'])).','.
+						zbx_dbstr($item['trapper_hosts']).','.zbx_dbstr($item['snmp_port']).','.zbx_dbstr($item['units']).','.(!$item['multiplier'] ? '0':zbx_dbstr($item['multiplier'])).','.
 						intval($item['delta']).','.zbx_dbstr($item['snmpv3_securityname']).','.intval($item['snmpv3_securitylevel']).','.
 						zbx_dbstr($item['snmpv3_authpassphrase']).','.zbx_dbstr($item['snmpv3_privpassphrase']).','.
-						zbx_dbstr($item['formula']).','.(!$item['trends'] ? '0':$item['trends']).','.zbx_dbstr($item['logtimefmt']).','.(!$item['valuemapid'] ? '0':$item['valuemapid']).','.
+						zbx_dbstr($item['formula']).','.(!$item['trends'] ? '0':zbx_dbstr($item['trends'])).','.zbx_dbstr($item['logtimefmt']).','.(!$item['valuemapid'] ? '0':zbx_dbstr($item['valuemapid'])).','.
 						zbx_dbstr($item['delay_flex']).','.zbx_dbstr($item['params']).','.
-						zbx_dbstr($item['ipmi_sensor']).','.$item['templateid'].','.intval($item['authtype']).','.
+						zbx_dbstr($item['ipmi_sensor']).','.zbx_dbstr($item['templateid']).','.intval($item['authtype']).','.
 						zbx_dbstr($item['username']).','.zbx_dbstr($item['password']).','.
 						zbx_dbstr($item['publickey']).','.zbx_dbstr($item['privatekey']).')'
 			);
@@ -416,7 +416,7 @@
 
 		foreach($item['applications'] as $key => $appid){
 			$itemappid=get_dbid('items_applications','itemappid');
-			DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES('.$itemappid.','.$itemid.','.$appid.')');
+			DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES('.$itemappid.','.zbx_dbstr($itemid).','.zbx_dbstr($appid).')');
 		}
 
 		info(S_ADDED_NEW_ITEM.SPACE.'"'.$host['host'].':'.$item['key_'].'"');
@@ -457,11 +457,11 @@
 			if($status != $old_status){
 /*				unset($itemids[$row['itemid']]);*/
 				if ($status==ITEM_STATUS_ACTIVE)
-					$sql='UPDATE items SET status='.$status.",error='' ".
-						' WHERE itemid='.$row['itemid'];
+					$sql='UPDATE items SET status='.zbx_dbstr($status).",error='' ".
+						' WHERE itemid='.zbx_dbstr($row['itemid']);
 				else
-					$sql='UPDATE items SET status='.$status.
-						' WHERE itemid='.$row['itemid'];
+					$sql='UPDATE items SET status='.zbx_dbstr($status).
+						' WHERE itemid='.zbx_dbstr($row['itemid']);
 
 				$result &= DBexecute($sql);
 				if ($result){
@@ -526,8 +526,8 @@
 
 		$sql = 'SELECT itemid, hostid, templateid '.
 				' FROM items '.
-				' WHERE hostid='.$item['hostid'].
-					' AND itemid<>'.$itemid.
+				' WHERE hostid='.zbx_dbstr($item['hostid']).
+					' AND itemid<>'.zbx_dbstr($itemid).
 					' AND key_='.zbx_dbstr($item['key_']);
 		$db_item = DBfetch(DBselect($sql));
 		if($db_item && (($db_item['templateid'] != 0) || ($item['templateid'] == 0))){
@@ -535,7 +535,7 @@
 			return FALSE;
 		}
 // first update child items
-		$db_tmp_items = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.$itemid);
+		$db_tmp_items = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.zbx_dbstr($itemid));
 		while($db_tmp_item = DBfetch($db_tmp_items)){
 			$child_item_params = $item_in_params;
 
@@ -576,54 +576,54 @@
 		}
 
 		$item_old = get_item_by_itemid($itemid);
-		DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.$itemid.' AND key_<>'.zbx_dbstr($item['key_']));
+		DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.zbx_dbstr($itemid).' AND key_<>'.zbx_dbstr($item['key_']));
 
 		if($upd_app){
-			$result = DBexecute('DELETE FROM items_applications WHERE itemid='.$itemid);
+			$result = DBexecute('DELETE FROM items_applications WHERE itemid='.zbx_dbstr($itemid));
 			foreach($item['applications'] as $appid){
 				$itemappid=get_dbid('items_applications','itemappid');
-				DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES ('.$itemappid.','.$itemid.','.$appid.')');
+				DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES ('.$itemappid.','.zbx_dbstr($itemid).','.zbx_dbstr($appid).')');
 			}
 		}
 
 		if($item['status'] == ITEM_STATUS_ACTIVE)
-			DBexecute("UPDATE items SET error='' WHERE itemid=".$itemid.' and status<>'.$item['status']);
+			DBexecute("UPDATE items SET error='' WHERE itemid=".zbx_dbstr($itemid).' and status<>'.zbx_dbstr($item['status']));
 
 		$result=DBexecute(
 			'UPDATE items '.
 			' SET description='.zbx_dbstr($item['description']).','.
 				'key_='.zbx_dbstr($item['key_']).','.
-				'hostid='.$item['hostid'].','.
-				'delay='.$item['delay'].','.
-				'history='.$item['history'].','.
-				'type='.$item['type'].','.
+				'hostid='.zbx_dbstr($item['hostid']).','.
+				'delay='.zbx_dbstr($item['delay']).','.
+				'history='.zbx_dbstr($item['history']).','.
+				'type='.zbx_dbstr($item['type']).','.
 				'snmp_community='.zbx_dbstr($item['snmp_community']).','.
 				'snmp_oid='.zbx_dbstr($item['snmp_oid']).','.
-				'value_type='.$item['value_type'].','.
-				'data_type='.$item['data_type'].','.
+				'value_type='.zbx_dbstr($item['value_type']).','.
+				'data_type='.zbx_dbstr($item['data_type']).','.
 				'trapper_hosts='.zbx_dbstr($item['trapper_hosts']).','.
-				'snmp_port='.$item['snmp_port'].','.
+				'snmp_port='.zbx_dbstr($item['snmp_port']).','.
 				'units='.zbx_dbstr($item['units']).','.
-				'multiplier='.$item['multiplier'].','.
-				'delta='.$item['delta'].','.
+				'multiplier='.zbx_dbstr($item['multiplier']).','.
+				'delta='.zbx_dbstr($item['delta']).','.
 				'snmpv3_securityname='.zbx_dbstr($item['snmpv3_securityname']).','.
-				'snmpv3_securitylevel='.$item['snmpv3_securitylevel'].','.
+				'snmpv3_securitylevel='.zbx_dbstr($item['snmpv3_securitylevel']).','.
 				'snmpv3_authpassphrase='.($item['snmpv3_securitylevel'] == ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV || $item['snmpv3_securitylevel'] == ITEM_SNMPV3_SECURITYLEVEL_AUTHNOPRIV ? zbx_dbstr($item['snmpv3_authpassphrase']) : "''").','.
 				'snmpv3_privpassphrase='.($item['snmpv3_securitylevel'] == ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV ? zbx_dbstr($item['snmpv3_privpassphrase']) : "''").','.
 				'formula='.zbx_dbstr($item['formula']).','.
-				'trends='.$item['trends'].','.
+				'trends='.zbx_dbstr($item['trends']).','.
 				'logtimefmt='.zbx_dbstr($item['logtimefmt']).','.
-				'valuemapid='.$item['valuemapid'].','.
+				'valuemapid='.zbx_dbstr($item['valuemapid']).','.
 				'delay_flex='.zbx_dbstr($item['delay_flex']).','.
 				'params='.zbx_dbstr($item['params']).','.
 				'ipmi_sensor='.zbx_dbstr($item['ipmi_sensor']).','.
-				'templateid='.$item['templateid'].','.
-				'authtype='.$item['authtype'].','.
+				'templateid='.zbx_dbstr($item['templateid']).','.
+				'authtype='.zbx_dbstr($item['authtype']).','.
 				'username='.zbx_dbstr($item['username']).','.
 				'password='.zbx_dbstr($item['password']).','.
 				'publickey='.zbx_dbstr($item['publickey']).','.
 				'privatekey='.zbx_dbstr($item['privatekey']).
-			' WHERE itemid='.$itemid);
+			' WHERE itemid='.zbx_dbstr($itemid));
 
 		if ($result){
 			$item_new = get_item_by_itemid($itemid);
@@ -735,7 +735,7 @@
 			}
 
 			if ($unlink_mode) {
-				if (DBexecute('UPDATE items SET templateid=0 WHERE itemid='.$db_item["itemid"])) {
+				if (DBexecute('UPDATE items SET templateid=0 WHERE itemid='.zbx_dbstr($db_item["itemid"]))) {
 					info(sprintf(S_ITEM_UNLINKED, $host['host'].':'.$db_item["key_"]));
 				}
 			}
@@ -861,7 +861,7 @@
 	}
 
 	function get_item_by_itemid($itemid){
-		$row = DBfetch(DBselect('select * from items where itemid='.$itemid));
+		$row = DBfetch(DBselect('select * from items where itemid='.zbx_dbstr($itemid)));
 		if($row){
 			return	$row;
 		}
@@ -876,7 +876,7 @@
 					'formula,trends,logtimefmt,valuemapid,delay_flex,params,ipmi_sensor,templateid,'.
 					'authtype,username,password,publickey,privatekey '.
 			' FROM items '.
-			' WHERE itemid='.$itemid;
+			' WHERE itemid='.zbx_dbstr($itemid);
 		$row = DBfetch(DBselect($sql));
 		if($row){
 			return	$row;
@@ -913,7 +913,7 @@
 		if(isset($itemid)){
 			$sql = 'SELECT src.* '.
 							' FROM items src, items dest '.
-							' WHERE dest.itemid='.$itemid.
+							' WHERE dest.itemid='.zbx_dbstr($itemid).
 								' AND src.key_=dest.key_ '.
 								' AND '.DBcondition('src.hostid',$dest_hostids);
 
@@ -1006,7 +1006,7 @@
 
 		foreach ($itemids as $id) {	/* The section should be improved */
 			$item_old = get_item_by_itemid($id);
-			$result = DBexecute('DELETE FROM items WHERE itemid='.$id);
+			$result = DBexecute('DELETE FROM items WHERE itemid='.zbx_dbstr($id));
 			if ($result)
 				add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_ITEM, $id, $item_old['description'], 'items', NULL, NULL);
 			else
@@ -1292,7 +1292,7 @@
 
 		foreach($applications as $appid){
 			$db_apps = DBselect("select a1.applicationid from applications a1, applications a2".
-					" where a1.name=a2.name and a1.hostid=".$hostid." and a2.applicationid=".$appid);
+					" where a1.name=a2.name and a1.hostid=".zbx_dbstr($hostid)." and a2.applicationid=".zbx_dbstr($appid));
 			$db_app = DBfetch($db_apps);
 			if(!$db_app) continue;
 			array_push($child_applications,$db_app["applicationid"]);
@@ -1463,18 +1463,18 @@
 		}
 
 		if($last == 0){
-			$sql = 'select value from '.$table.' where itemid='.$db_item['itemid'].' and clock<='.$clock.
+			$sql = 'select value from '.$table.' where itemid='.zbx_dbstr($db_item['itemid']).' and clock<='.zbx_dbstr($clock).
 					' order by itemid,clock desc';
 			$row = DBfetch(DBselect($sql, 1));
 			if($row)
 				$value = $row["value"];
 		}
 		else{
-			$sql = "select max(clock) as clock from $table where itemid=".$db_item["itemid"];
+			$sql = "select max(clock) as clock from $table where itemid=".zbx_dbstr($db_item["itemid"]);
 			$row = DBfetch(DBselect($sql));
 			if($row && !is_null($row["clock"])){
 				$clock = $row["clock"];
-				$sql = "select value from $table where itemid=".$db_item["itemid"]." and clock=$clock";
+				$sql = "select value from $table where itemid=".zbx_dbstr($db_item["itemid"]).' and clock='.zbx_dbstr($clock);
 				$row = DBfetch(DBselect($sql, 1));
 				if($row)
 					$value = $row["value"];
